﻿using StudentManager.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StudentManager.Common
{
	public class ErrorInfo
	{
		public int ID { get; set; } = 0;
		public bool Status { get; set; } = false;
	}

	public class ErrorSet
    {
		public int TotalCount { get; set; } = 0;
		public int CorrectCount { get; set; } = 0;
		public Dictionary<int, ErrorInfo> Errores { get; set; } = new Dictionary<int, ErrorInfo>();
		public List<int> ErrorArray { get; set; } = new List<int>();
		public List<int> CorrectArray { get; set; } = new List<int>();

		public void InitErrorSetData()
		{
            foreach (var item in Errores)
            {
                if(item.Value.Status ==  true) CorrectArray.Add(item.Value.ID);
				else ErrorArray.Add(item.Value.ID);
            }
        }

		public void AddErrorQuestion(int id)
		{
			if (Errores.ContainsKey(id))
			{
				TotalCount++;
				ErrorArray.Add(id);
			}
			else
			{
				Errores.Add(id, new ErrorInfo { ID = id });
			}
		}

		public void AddCorrectQuestion(int id)
		{
			if (Errores.ContainsKey(id))
			{
				TotalCount++;
				CorrectCount++;
				Errores[id].Status = true;

				ErrorArray.Remove(id);
				CorrectArray.Add(id);
			}
		}


		public void AddErrorQuestion(QuestionData question)
		{
			if (Errores.ContainsKey(question.Id))
			{
				TotalCount++;
				ErrorArray.Add(question.Id);
			}
			else
			{
				Errores.Add(question.Id, new ErrorInfo { ID = question.Id });
			}
		}

		public void AddCorrectQuestion(QuestionData question)
		{
			if (Errores.ContainsKey(question.Id))
			{
				TotalCount++;
				CorrectCount++;
				Errores[question.Id].Status = true;

				ErrorArray.Remove(question.Id);
				CorrectArray.Add(question.Id);
			}
		}
	}
}
