﻿using Microsoft.VisualBasic;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;

namespace StudentManager.Data
{
    public static class QuestionLib
    {
		public static string LibPath = "C:\\Users\\zc\\Desktop\\FileLib\\";
		public static string FileName = "questionLib.dbqi";
		public static Dictionary<int, QuestionData> QuestionDic { get; set; } = new Dictionary<int, QuestionData>();

		public static void Load()
		{
			QuestionDic.Clear();

			Debug.Assert(Path.Exists(LibPath));
			string file = File.ReadAllText(LibPath + FileName);
			QuestionDic = JsonSerializer.Deserialize<Dictionary<int, QuestionData>>(file);
		}
		public static void Save()
		{
			File.WriteAllText((LibPath + FileName), JsonSerializer.Serialize(QuestionDic));
		}

		public static void Test()
		{
			QuestionDic.Add(1, new QuestionData
			{
				Id = 1,
				Type = "test"
			});
		}

		public static QuestionData Get(int id)
		{
			if (!QuestionDic.ContainsKey(id)) return null;

			return QuestionDic[id];
		}

		public static void Add(QuestionData question)
		{
			QuestionDic.Add(question.Id, question);
		}

		public static void Remove(QuestionData question)
		{
			QuestionDic.Remove(question.Id);
		}

		public static void Remove(int id)
		{
			QuestionDic.Remove(id);
		}
	}
}
